/* 
TEST KÓD PRE ZÁKLADNÚ DOSKU DENUINO FUTURE V1.0

AK STE ÚPLNÝ ZAČIATOČNÍK A NIDKY STE NEPRACOVALI S RIADIACOU JEDNOTKOU OD Espressif: ESP32, PROSÍM
PRED ZAČATÍM SI STIAHNITE OVLÁDAČ ESP32 modulu v ARDUINO IDE, BOARDS MANAGER:
1. "esp32 by Espressif" (vyhladajte esp32 a kliknite na INSTALL)
2. Zvoľte základnú dosku "ESP32 Dev Module" v Tools. (horný menu bar)
3. Zvoľte vhodný PORT.

PRE SPRÁVNU FUNKČNOSŤ JE POTREBNÉ STIAHNUŤ POTREBNÉ KNIŽNICE PRIAMO Z ARDUINO IDE, SEKCIA KNIŽNICE: 
1. "Adafruit NeoPixel by Adafruit" (vyhladajte Adafruit NeoPixel a kliknite na INSTALL)

Po dokončení môžete začat testovať. :)
CRTL+U (upload code)

Ak potrebujete pomoc, neváhajte nás konktaktovať.
info@denuino.sk
*/
#include <Adafruit_NeoPixel.h>
#define LED_PIN    17 // WS2812 PIN
#define LED_COUNT 4   // počet diód

Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);

void setup() {
  strip.begin();           
  strip.show();           
  strip.setBrightness(150); // JAS, max. je 255)
}

void loop() {
  colorWipe(strip.Color(255,   0,   0), 50); // Červená
  colorWipe(strip.Color(  0, 255,   0), 50); // Zelená
  colorWipe(strip.Color(  0,   0, 255), 50); // Modrá

  theaterChase(strip.Color(127, 127, 127), 50); 
  theaterChase(strip.Color(127,   0,   0), 50); 
  theaterChase(strip.Color(  0,   0, 127), 50); 

  rainbow(10);             
  theaterChaseRainbow(50); 
}

void colorWipe(uint32_t color, int wait) {
  for(int i=0; i<strip.numPixels(); i++) { 
    strip.setPixelColor(i, color);         
    strip.show();                          
    delay(wait);                          
  }
}

void theaterChase(uint32_t color, int wait) {
  for(int a=0; a<10; a++) {  
    for(int b=0; b<3; b++) { 
      strip.clear();         
      
      for(int c=b; c<strip.numPixels(); c += 3) {
        strip.setPixelColor(c, color); 
      }
      strip.show(); 
      delay(wait);  
    }
  }
}

void rainbow(int wait) {
  for(long firstPixelHue = 0; firstPixelHue < 5*65536; firstPixelHue += 256) {
    strip.rainbow(firstPixelHue);
    strip.show(); 
    delay(wait);  
  }
}

void theaterChaseRainbow(int wait) {
  int firstPixelHue = 0;     
  for(int a=0; a<30; a++) {  
    for(int b=0; b<3; b++) { 
      strip.clear();         
      for(int c=b; c<strip.numPixels(); c += 3) {
        int      hue   = firstPixelHue + c * 65536L / strip.numPixels();
        uint32_t color = strip.gamma32(strip.ColorHSV(hue)); 
        strip.setPixelColor(c, color); 
      }
      strip.show();                
      delay(wait);                 
      firstPixelHue += 65536 / 90; 
    }
  }
}
